Pythonで自作の例外を発生させるraiseの使い方を現役エンジニアが解説【初心者向け】

初心者向けにPythonで自作の例外を発生させるraiseの使い方について現役エンジニアが解説しています。raiseを使うと故井に例外を発生させることが出来ます。例えば自作の例外処理などを導入したい場合などに使います。

TechAcademyマガジンは受講者数No.1のオンラインプログラミングスクールTechAcademy [テックアカデミー]が運営。初心者向けに解説した記事を公開中。現役エンジニアの方はこちらをご覧ください。

Pythonで自作の例外を発生させるraiseの使い方について解説します。

そもそもPythonについてよく分からないという方は、Pythonとは何なのか解説した記事を読むとさらに理解が深まります。

 

なお本記事は、TechAcademyのオンラインブートキャンプPython講座の内容をもとに紹介しています。

 

田島悠介

今回は、Pythonに関する内容だね!

大石ゆかり

どういう内容でしょうか?

田島悠介

Pythonで自作の例外を発生させるraiseの使い方について詳しく説明していくね!

大石ゆかり

お願いします!

 

raiseとは?

プログラムの中で何か問題を検出したときに、自作の例外を発生させたい場合にはraiseを使います。

リスト(配列)に範囲外のインデックスを使ってアクセスすると、Pythonに元から組み込まれているIndexErrorという例外が発生します。しかし、作るプログラムによっては「組み込み例外は発生しないけど、異常なケースなので例外を発生させたい」ことがあります。

そのようなときに、raiseを使って自作の例外を発生させることができます。

 

raiseの基本的な書き方

raise <Exception Class>[(<message>)] 

 
と記述することで例外を発生させることができます。

メッセージは省略することも可能ですが、メンテナンス性や利用者の立場などを考えると、原因や詳細などを記述するようにした方がよいでしょう。
 

[PR] Pythonで挫折しない学習方法を動画で公開中

実際に書いてみよう

Pythonのコンソールで確認してみましょう。
まずはメッセージを省略した以外を発生させてみます。
 

>>> raise Exception
Traceback (most recent call last):
File "<stdin>", line 1, in <module>
Exception

 

続いてメッセージを入力してみましょう。例外発生時のトレースログに、入力した文字が入っていますね。

 

>>> raise Exception("例外が発生しました")
Traceback (most recent call last):
File "<stdin>", line 1, in <module>
Exception: 例外が発生しました

 

最後にさきほどの例外をtry/exceptで捕捉してみましょう。
トレースログが表示されずに、例外メッセージをprintできているのがわかります。
 

>>> try:
... raise Exception("例外が発生しました")
... except Exception as e:
... print(e)
...
例外が発生しました

 
今回は簡略化のためにExceptionクラスを使いましたが、実際のプログラムでは適切な例外クラスを選ぶ、もしくは自分で作った例外クラスを使う方が良いでしょう。

Pythonの組み込み例外は公式ドキュメントで確認してみてください。
 

監修してくれたメンター

稲員さん

フリーランスエンジニア。
大手SEからフリーランスのWeb系エンジニアにジョブチェンジ。

経験言語:Ruby、Rails、Python、C/C++、Java、Perl、HTML/CSS3、JavaScript、CoffeeScript,Node.js。
おうち大好きマンです。

 

大石ゆかり

内容分かりやすくて良かったです!

田島悠介

ゆかりちゃんも分からないことがあったら質問してね!

大石ゆかり

分かりました。ありがとうございます!

 

TechAcademyでは、初心者でもPythonを使った人工知能(AI)や機械学習の基礎を習得できるオンラインブートキャンプPython講座を開催しています。

挫折しない学習方法を知れる説明動画や、現役エンジニアとのビデオ通話とチャットサポート、学習用カリキュラムを体験できる無料体験も実施しているので、ぜひ参加してみてください。